//
// ArticleList.java: Class file for WO Component 'ArticleList'
// Project PcPro
//
// Created by paul on 08/04/2006
//

import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eocontrol.*;
import com.webobjects.eoaccess.*;

public class ArticleList extends WOComponent {
	protected int batchNo = 0;
	protected int batchSize = 10;

	/** @TypeInfo Article */
	protected NSArray articles;
	/** @TypeInfo Article */
	public EOEnterpriseObject article;

    public ArticleList(WOContext context) {
        super(context);
		articles = new NSArray();
    }

	public int batchNo() {
		return batchNo;
	}
	public void setBatchNo(int newBatchNo) {
		batchNo = newBatchNo;
	}
	public int displayBatchNo() {
		return batchNo + 1;
	}

	public int batchSize() {
		return batchSize;
	}
	public void setBatchSize(int newBatchSize) {
		batchSize = newBatchSize;
	}

	/** @TypeInfo Article */
	public NSArray articles() {
		return articles;
	}
	public void setArticles(NSArray newArticles) {
		articles = newArticles;
	}
	
	public NSArray displayedArticles() {
		return articles.subarrayWithRange(new NSRange(batchNo * batchSize, batchSize));
	}

	public int batchCount() {
		return (articles.count() / batchSize()) + 1;
	}
	
	public boolean hasMultipleBatches() {
		return (batchCount() > 1);
	}
	
	public int nextBatch() {
		return (displayBatchNo() < batchCount()) ? batchNo() + 1 : batchNo();
	}

	public int previousBatch() {
		return (batchNo() > 0) ? batchNo() - 1 : 0;
	}

}
