// Article.java
// Created on Sun Jun 18 18:24:59  2000 by Apple EOModeler Version 378.3


import com.webobjects.foundation.*;
import com.webobjects.eocontrol.*;
import com.webobjects.eoaccess.*;
import java.util.*;
import java.math.BigDecimal;

public class Article extends _Article {

    public Article() {
        super();
    }

    public String body() {
        NSArray tmpArray = NSArray.componentsSeparatedByString(super.body(), "\n\n");
        String tmpStr = tmpArray.componentsJoinedByString("<p>");
        tmpArray = NSArray.componentsSeparatedByString(tmpStr, "\n");
        tmpStr = tmpArray.componentsJoinedByString("<br>");
        return tmpStr;
    }

    public String rawBody() {
        return super.body();
    }

    public String page() {
//        System.out.println("page: " + page);
//        System.out.println("category: " + category.valueForKey("title"));
//        System.out.println("category article page: " + category.valueForKey("articlePage"));
        if (super.page() != null) return super.page();
        if (category() != null && category().valueForKey("articlePage") != null)
            return (String)category().valueForKey("articlePage");
        return null;
    }

    public boolean publishFlag() {
		if (publish() == null)
            return false;
        if (publish().intValue() == 1)
			return true;
        return false;
    }
    public void setPublishFlag(boolean newPublishFlag) {
        if (newPublishFlag)
            setPublish(new Integer(1));
        else
            setPublish(new Integer (0));
    }
	
    public boolean showNew() {
        if (publishDate() == null) return false;
        double interval = publishDate().timeIntervalSinceNow();
        if (interval < 0 && interval > (-45.0 * 24.0 * 60.0 * 60.0)) return true;
        return false;
    }
	
	public String key() {
		NSDictionary keyDict = EOUtilities.primaryKeyForObject(editingContext(), this);
		Enumeration i = keyDict.objectEnumerator();
		String key = "";
		while (i.hasMoreElements()) {
			Object o = i.nextElement();
			key += o.toString();
		}
		return key;
	}
	
	public static Article articleWithKey(String key) {
		Integer keyNum;
		try {
			keyNum = new Integer(key);
		} catch (NumberFormatException ex) {
			NSLog.debug.appendln("NumberFormatException on Article key: " + key);
			return null;
		}
		return (Article)EOUtilities.objectWithPrimaryKeyValue(new EOEditingContext(), "Article", keyNum);
	}
	
	public static NSArray allArticles() {
		NSMutableDictionary bindings = new NSMutableDictionary();
		NSTimestamp now = new NSTimestamp();
        bindings.setObjectForKey(now, "now");
        bindings.setObjectForKey("PDA", "cat");
		return EOUtilities.objectsWithFetchSpecificationAndBindings(new EOEditingContext(), "Article", "articleFetch", bindings);
	}
	
}
